/*static char RcsId[] = "$Header: MDSSignalP.h,v 5.14 99/10/13 15:02:35 pons Exp $";*/

/*********************************************************************
 *
 * File:	MDSSignalP.h
 *
 * Project:	Multi Signal Device Server
 *
 * Description:	Device Server Class which is a top Layer of DSSignal
 		Class to handle multiple signals.
 *
 * Author(s):	Ingrid Fladmark
 *
 * Original:	24th of january 1997	
 *
 * $Log:	MDSSignalP.h,v $
 * Revision 5.14  99/10/13  15:02:35  15:02:35  pons ()
 * Correction for OS9 compilation (strdup)
 * 
 * Revision 5.13  99/10/11  17:06:16  17:06:16  pons ()
 * Correction for multi-nethost
 * 
 * Revision 5.12  99/08/20  17:29:54  17:29:54  pons ()
 * Multi Nethost support
 * 
 * Revision 5.11  99/02/12  14:38:10  14:38:10  pons ()
 * Correction
 * 
 * Revision 5.10  99/02/05  17:39:58  17:39:58  pons ()
 * Correction
 * 
 * Revision 5.9  99/02/05  16:52:05  16:52:05  pons ()
 * Add dev_get_sig_list() , dev_get_sig_config_from_name()
 * 
 * Revision 5.8  99/02/04  17:40:56  17:40:56  pons ()
 * Fast implementation of dev_get_sig_config
 * 
 * Revision 5.7  98/10/06  16:53:24  16:53:24  meyer (J.Meyer)
 * Added error if no signal list is defined.
 * 
 * Revision 5.5  97/12/05  15:45:40  15:45:40  meyer (J.Meyer)
 * Corrected missing return in dev_get_sig_config()
 * 
 * Revision 5.4  97/12/05  10:02:26  10:02:26  meyer (J.Meyer)
 * Added dev_get_sig_config and DevGetSigObject methode
 * 
 * Revision 5.3  97/07/08  09:26:37  09:26:37  meyer (J.Meyer)
 * Corrected bug in read properties() and added reading of a signal list for the class.
 * 
 * Revision 5.2  97/06/10  13:53:17  13:53:17  meyer (J.Meyer)
 * Found another memory leak in read_alarms().
 * 
 * Revision 5.1  97/06/10  11:09:48  11:09:48  meyer (J.Meyer)
 * Corrected RCS header.
 * 
 * Revision 5.0  97/06/10  11:04:46  11:04:46  meyer (J.Meyer)
 * Corrected memory leak in read_alarms().
 * 
 * Revision 1.1  97/06/10  10:29:02  10:29:02  fladmark (I.Fladmark)
 * Initial revision
 * 
 * 
 * Copyright (c) 1994 by European Synchrotron Radiation Facility, 
 *                     Grenoble, France
 *
 * File generated by the Automatic Class Generation Tool,  2.4 
 * (Fri Jan 24 11:57:57 1997).
 *
 *********************************************************************/

#ifndef _MDSSIGNALP_H
#define _MDSSIGNALP_H

#include <DSSignalP.h>
#define 	MAXLENGTH	128


typedef struct _MDSSignalClassPart
{
   int	nada;
} MDSSignalClassPart;



typedef struct _MDSSignalPart
{
   	DevVarStringArray signal_names; /* List of all signals to handle. */
	Dssignal	  *signal_obj;
	DevVarStringArray *signals_properties;
	char              **property_ptr;
	long              *alarm_result;
} MDSSignalPart;



typedef struct _MDSSignalClassRec
{
   DevServerClassPart	devserver_class;
				
   MDSSignalClassPart	mDSSignal_class;
} MDSSignalClassRec;



extern MDSSignalClassRec mDSSignalClassRec;


typedef struct _MDSSignalRec
{
   DevServerPart 	devserver;
				
   MDSSignalPart 	mDSSignal;
} MDSSignalRec;

#endif /*_MDSSIGNALP_H*/

